module Common.Utils where

indexed i list = zip [i .. (i + length list - 1)] list


(>>>) a b = b . a




split :: (a -> Bool) -> [a] -> [[a]]
split pred [] = []
split pred (l:ls) = if pred l
	then [l] : split pred ls
 	else taken : split pred rem
	where
		(taken, rem) = break pred (l:ls)


mapFirst  f = map (\ (x,y) -> (f x, y))

mapSecond f = map (\ (x,y) -> (x, f y))


try_alt :: [a -> Maybe b] -> b -> a -> b
try_alt []     failure _ = failure
try_alt (f:fs) failure input = case f input of
	Just success -> success
	Nothing -> try_alt fs failure input
